import{s as _e,n as ve,o as ye}from"../chunks/scheduler.8c3d61f6.js";import{S as ze,i as Ne,g as i,s as r,r as l,A as xe,h as s,f as n,c as a,j as I,u as f,x as M,k as V,y as d,a as o,v as u,d as g,t as p,w as c}from"../chunks/index.da70eac4.js";import{D as ie}from"../chunks/Docstring.ee4b6913.js";import{H as j,E as Ae}from"../chunks/EditOnGithub.1e64e623.js";function Le(ue){let $,k,q,F,v,R,y,ge="Customized normalization layers for supporting various models in 🤗 Diffusers.",U,z,B,b,N,se,P,pe="Norm layer modified to incorporate timestep embeddings.",J,x,K,h,A,me,S,ce="Norm layer adaptive layer norm zero (adaLN-Zero).",Q,L,W,m,T,de,D,$e="Norm layer adaptive layer norm single (adaLN-single).",le,E,be='As proposed in PixArt-Alpha (see: <a href="https://arxiv.org/abs/2310.00426" rel="nofollow">https://arxiv.org/abs/2310.00426</a>; Section 2.3).',X,w,Y,_,C,fe,Z,he="GroupNorm layer modified to incorporate timestep embeddings.",ee,G,te,O,ne;return v=new j({props:{title:"Normalization layers",local:"normalization-layers",headingTag:"h1"}}),z=new j({props:{title:"AdaLayerNorm",local:"diffusers.models.normalization.AdaLayerNorm",headingTag:"h2"}}),N=new ie({props:{name:"class diffusers.models.normalization.AdaLayerNorm",anchor:"diffusers.models.normalization.AdaLayerNorm",parameters:[{name:"embedding_dim",val:": int"},{name:"num_embeddings",val:": int"}],parametersDescription:[{anchor:"diffusers.models.normalization.AdaLayerNorm.embedding_dim",description:"<strong>embedding_dim</strong> (<code>int</code>) &#x2014; The size of each embedding vector.",name:"embedding_dim"},{anchor:"diffusers.models.normalization.AdaLayerNorm.num_embeddings",description:"<strong>num_embeddings</strong> (<code>int</code>) &#x2014; The size of the embeddings dictionary.",name:"num_embeddings"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/models/normalization.py#L31"}}),x=new j({props:{title:"AdaLayerNormZero",local:"diffusers.models.normalization.AdaLayerNormZero",headingTag:"h2"}}),A=new ie({props:{name:"class diffusers.models.normalization.AdaLayerNormZero",anchor:"diffusers.models.normalization.AdaLayerNormZero",parameters:[{name:"embedding_dim",val:": int"},{name:"num_embeddings",val:": Optional = None"},{name:"norm_type",val:" = 'layer_norm'"},{name:"bias",val:" = True"}],parametersDescription:[{anchor:"diffusers.models.normalization.AdaLayerNormZero.embedding_dim",description:"<strong>embedding_dim</strong> (<code>int</code>) &#x2014; The size of each embedding vector.",name:"embedding_dim"},{anchor:"diffusers.models.normalization.AdaLayerNormZero.num_embeddings",description:"<strong>num_embeddings</strong> (<code>int</code>) &#x2014; The size of the embeddings dictionary.",name:"num_embeddings"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/models/normalization.py#L66"}}),L=new j({props:{title:"AdaLayerNormSingle",local:"diffusers.models.normalization.AdaLayerNormSingle",headingTag:"h2"}}),T=new ie({props:{name:"class diffusers.models.normalization.AdaLayerNormSingle",anchor:"diffusers.models.normalization.AdaLayerNormSingle",parameters:[{name:"embedding_dim",val:": int"},{name:"use_additional_conditions",val:": bool = False"}],parametersDescription:[{anchor:"diffusers.models.normalization.AdaLayerNormSingle.embedding_dim",description:"<strong>embedding_dim</strong> (<code>int</code>) &#x2014; The size of each embedding vector.",name:"embedding_dim"},{anchor:"diffusers.models.normalization.AdaLayerNormSingle.use_additional_conditions",description:"<strong>use_additional_conditions</strong> (<code>bool</code>) &#x2014; To use additional conditions for normalization or not.",name:"use_additional_conditions"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/models/normalization.py#L172"}}),w=new j({props:{title:"AdaGroupNorm",local:"diffusers.models.normalization.AdaGroupNorm",headingTag:"h2"}}),C=new ie({props:{name:"class diffusers.models.normalization.AdaGroupNorm",anchor:"diffusers.models.normalization.AdaGroupNorm",parameters:[{name:"embedding_dim",val:": int"},{name:"out_dim",val:": int"},{name:"num_groups",val:": int"},{name:"act_fn",val:": Optional = None"},{name:"eps",val:": float = 1e-05"}],parametersDescription:[{anchor:"diffusers.models.normalization.AdaGroupNorm.embedding_dim",description:"<strong>embedding_dim</strong> (<code>int</code>) &#x2014; The size of each embedding vector.",name:"embedding_dim"},{anchor:"diffusers.models.normalization.AdaGroupNorm.num_embeddings",description:"<strong>num_embeddings</strong> (<code>int</code>) &#x2014; The size of the embeddings dictionary.",name:"num_embeddings"},{anchor:"diffusers.models.normalization.AdaGroupNorm.num_groups",description:"<strong>num_groups</strong> (<code>int</code>) &#x2014; The number of groups to separate the channels into.",name:"num_groups"},{anchor:"diffusers.models.normalization.AdaGroupNorm.act_fn",description:"<strong>act_fn</strong> (<code>str</code>, <em>optional</em>, defaults to <code>None</code>) &#x2014; The activation function to use.",name:"act_fn"},{anchor:"diffusers.models.normalization.AdaGroupNorm.eps",description:"<strong>eps</strong> (<code>float</code>, <em>optional</em>, defaults to <code>1e-5</code>) &#x2014; The epsilon value to use for numerical stability.",name:"eps"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/models/normalization.py#L205"}}),G=new Ae({props:{source:"https://github.com/huggingface/diffusers/blob/main/docs/source/en/api/normalization.md"}}),{c(){$=i("meta"),k=r(),q=i("p"),F=r(),l(v.$$.fragment),R=r(),y=i("p"),y.textContent=ge,U=r(),l(z.$$.fragment),B=r(),b=i("div"),l(N.$$.fragment),se=r(),P=i("p"),P.textContent=pe,J=r(),l(x.$$.fragment),K=r(),h=i("div"),l(A.$$.fragment),me=r(),S=i("p"),S.textContent=ce,Q=r(),l(L.$$.fragment),W=r(),m=i("div"),l(T.$$.fragment),de=r(),D=i("p"),D.textContent=$e,le=r(),E=i("p"),E.innerHTML=be,X=r(),l(w.$$.fragment),Y=r(),_=i("div"),l(C.$$.fragment),fe=r(),Z=i("p"),Z.textContent=he,ee=r(),l(G.$$.fragment),te=r(),O=i("p"),this.h()},l(e){const t=xe("svelte-u9bgzb",document.head);$=s(t,"META",{name:!0,content:!0}),t.forEach(n),k=a(e),q=s(e,"P",{}),I(q).forEach(n),F=a(e),f(v.$$.fragment,e),R=a(e),y=s(e,"P",{"data-svelte-h":!0}),M(y)!=="svelte-i4ltwe"&&(y.textContent=ge),U=a(e),f(z.$$.fragment,e),B=a(e),b=s(e,"DIV",{class:!0});var oe=I(b);f(N.$$.fragment,oe),se=a(oe),P=s(oe,"P",{"data-svelte-h":!0}),M(P)!=="svelte-3m9blw"&&(P.textContent=pe),oe.forEach(n),J=a(e),f(x.$$.fragment,e),K=a(e),h=s(e,"DIV",{class:!0});var re=I(h);f(A.$$.fragment,re),me=a(re),S=s(re,"P",{"data-svelte-h":!0}),M(S)!=="svelte-hxuhdq"&&(S.textContent=ce),re.forEach(n),Q=a(e),f(L.$$.fragment,e),W=a(e),m=s(e,"DIV",{class:!0});var H=I(m);f(T.$$.fragment,H),de=a(H),D=s(H,"P",{"data-svelte-h":!0}),M(D)!=="svelte-b3hofq"&&(D.textContent=$e),le=a(H),E=s(H,"P",{"data-svelte-h":!0}),M(E)!=="svelte-85nsxw"&&(E.innerHTML=be),H.forEach(n),X=a(e),f(w.$$.fragment,e),Y=a(e),_=s(e,"DIV",{class:!0});var ae=I(_);f(C.$$.fragment,ae),fe=a(ae),Z=s(ae,"P",{"data-svelte-h":!0}),M(Z)!=="svelte-gj85yz"&&(Z.textContent=he),ae.forEach(n),ee=a(e),f(G.$$.fragment,e),te=a(e),O=s(e,"P",{}),I(O).forEach(n),this.h()},h(){V($,"name","hf:doc:metadata"),V($,"content",Te),V(b,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),V(h,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),V(m,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),V(_,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(e,t){d(document.head,$),o(e,k,t),o(e,q,t),o(e,F,t),u(v,e,t),o(e,R,t),o(e,y,t),o(e,U,t),u(z,e,t),o(e,B,t),o(e,b,t),u(N,b,null),d(b,se),d(b,P),o(e,J,t),u(x,e,t),o(e,K,t),o(e,h,t),u(A,h,null),d(h,me),d(h,S),o(e,Q,t),u(L,e,t),o(e,W,t),o(e,m,t),u(T,m,null),d(m,de),d(m,D),d(m,le),d(m,E),o(e,X,t),u(w,e,t),o(e,Y,t),o(e,_,t),u(C,_,null),d(_,fe),d(_,Z),o(e,ee,t),u(G,e,t),o(e,te,t),o(e,O,t),ne=!0},p:ve,i(e){ne||(g(v.$$.fragment,e),g(z.$$.fragment,e),g(N.$$.fragment,e),g(x.$$.fragment,e),g(A.$$.fragment,e),g(L.$$.fragment,e),g(T.$$.fragment,e),g(w.$$.fragment,e),g(C.$$.fragment,e),g(G.$$.fragment,e),ne=!0)},o(e){p(v.$$.fragment,e),p(z.$$.fragment,e),p(N.$$.fragment,e),p(x.$$.fragment,e),p(A.$$.fragment,e),p(L.$$.fragment,e),p(T.$$.fragment,e),p(w.$$.fragment,e),p(C.$$.fragment,e),p(G.$$.fragment,e),ne=!1},d(e){e&&(n(k),n(q),n(F),n(R),n(y),n(U),n(B),n(b),n(J),n(K),n(h),n(Q),n(W),n(m),n(X),n(Y),n(_),n(ee),n(te),n(O)),n($),c(v,e),c(z,e),c(N),c(x,e),c(A),c(L,e),c(T),c(w,e),c(C),c(G,e)}}}const Te='{"title":"Normalization layers","local":"normalization-layers","sections":[{"title":"AdaLayerNorm","local":"diffusers.models.normalization.AdaLayerNorm","sections":[],"depth":2},{"title":"AdaLayerNormZero","local":"diffusers.models.normalization.AdaLayerNormZero","sections":[],"depth":2},{"title":"AdaLayerNormSingle","local":"diffusers.models.normalization.AdaLayerNormSingle","sections":[],"depth":2},{"title":"AdaGroupNorm","local":"diffusers.models.normalization.AdaGroupNorm","sections":[],"depth":2}],"depth":1}';function we(ue){return ye(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class De extends ze{constructor($){super(),Ne(this,$,we,Le,_e,{})}}export{De as component};
